﻿-- Load failure check
if not (Checklist2 and Checklist2.CORE_LOADED_SUCCESSFULLY) then return end

-- Register defaults
local defaults = {
  Settings = {    -- AddOn settings go in here
    ListLastUsed = "Welcome to Checklist2!",
    noteDisplayed = "Checklist2 User's Manual",
    tabDisplayed = 1
    },
  Lists = {}, -- Lists go in here
  Notes = {}, -- Notes go in here
  FuBarPlugin = { -- Plugin settings go in here
    tooltipWrap = 50
    }
  }

Checklist2:RegisterDB("Checklist2DB")
Checklist2:RegisterDefaults('profile', defaults)

Checklist2.NumOfPossibleLists = 2;
function Checklist2:GenerateRandomList()
  local list
  local l = math.random(1,2)
  if l == 1 then
    list = {
					["items"] = {
						["check16Text"] = "Got a suggestion? Feature requests? Bug reports? Post them on Curse or WoWInterface, or contact me at the WowAce IRC channel (irc://irc.freenode.org/wowace). I'm always online when I'm coding :)",
						["check2Text"] = "Contact me (Quezacolt) at Checklist2's WoWInterface or Curse page to report bugs or issues.",
						["check9Text"] = "As of this version, the Checklist2 window will fade out when the setup window is shown. All buttons in the main button are locked except for the checkboxes and the number buttons.",
						["check12Text"] = "http://files.wowace.com/   (most updated)",
						["check6Text"] = "To add or remove list items, right-click the tasks indicator on the bottom of this window.",
						["check13Text"] = "http://www.curse.com/downloads/details/8934/",
						["check11Text"] = "You can check for updates at the following sites:",
						["check3Text"] = "",
						["check15Text"] = "",
						["check4Text"] = "To modify your lists, right click on an existing list to bring up the dropdown menu.",
						["check8Text"] = "The list sharing feature allows your lists to be sent to other players, or broadcast over your group or guild to other Checklist2 users. Right click a list and select \"Send to...\" to use it.",
						["check14Text"] = "http://www.wowinterface.com/downloads/info7612-Checklist.html",
						["check10Text"] = "And that should be it for this version - Thank you for downloading Checklist2!",
						["check7Text"] = "Mousing over the FuBar/Minimap plugin will display all unchecked list items on the tooltip. The length of the text is adjustable - right click the plugin and select \"Tooltip width\"",
						["check1Text"] = "You are using Checklist v2.0.0.0725, the first official release version of Checklist2.",
						["check5Text"] = "To edit the text of a list item, click its number, located to the right of its checkbox.",
					},
					["checks"] = {
						["checked1"] = false,
						["checked5"] = false,
						["checked11"] = false,
						["checked13"] = false,
						["checked7"] = false,
						["checked12"] = false,
						["checked6"] = false,
						["checked9"] = false,
						["checked14"] = false,
						["checked10"] = false,
						["checked8"] = false,
						["checked3"] = false,
						["checked4"] = false,
						["checked15"] = false,
						["checked16"] = false,
						["checked2"] = false,
					},
				}
  else
    list = {
      checks = {
        checked1  = false,
        checked2  = false,
        checked3  = false,
        checked4  = false,
        checked5  = false,
        checked6  = false,
        checked7  = false,
        checked8  = false,
        checked9  = false,
        checked10 = false,
        checked11 = false,
        checked12 = false,
        checked13 = false,
        checked14 = false,
        checked15 = false,
        checked16 = false,
        checked17 = false
      },
      items = {
        check1Text  = "Do not stand at my grave and weep.",
        check2Text  = "I am not there. I do not sleep.",
        check3Text  = "I am in a thousand winds that blow,",
        check4Text  = "across Northrend's bright and shining snow.",
        check5Text  = "I am the gentle showers of rain,",
        check6Text  = "on Westfall's fields of golden grain.",
        check7Text  = "I am in the morning hush,",
        check8Text  = "of Stranglethorn's jungle, green and lush.",
        check9Text  = "I am in the drums loud and grand,",
        check10Text = "the thunderous hooves across Nagrand.",
        check11Text = "I am the stars warmly gleaming,",
        check12Text = "over Darnassus softly dreaming.",
        check13Text = "I am the birds that sing.",
        check14Text = "I am in each lovely thing.",
        check15Text = "Do not stand at my grave and cry.",
        check16Text = "I am not there. I do not die.",
        check17Text = " - Alicia's Poem (see http://www.wowwiki.com/Caylee_Dak)"
        }
      }
  end
  return list
end





function Checklist2:CreateHelpList()
  -- copied directly from my Checklist2 saved variables file, so it's kinda messed up...
  self.db.profile.Lists["Welcome to Checklist2!"] = {
    checks = {
      checked1 = false,
      checked2 = false,
    },
    items = {
      check1Text = "You are using Checklist v2.1.2.0826.",
      check2Text = "The tips that were formerly in this list were moved to the Notes section. There, you will find helpful info regarding the everyday use of Checklist2.",
    }
  }
  self:CollectListNames()
  self:ListScrollBarUpdate()
end

local userManual = (
[[Checklist version: ]] .. Checklist2.version .. [[ ($Date: 2008-05-14 23:31:21 -0400 (Wed, 14 May 2008) $)
$Revision: 73911 $

------------------------------------------------------------------------------------------------------------------
Contents
------------------------------------------------------------------------------------------------------------------

 - Section 1: Introduction
 - Section 2: Daily Use Guide - Notes
 - Section 3: Daily Use Guide - Checklist
 - Section 4: Contributors
 - Section 5: You can help, too!
 - Section 6: When Things Go Wrong - Reporting a Bug
 - Section 7: Distribution Sites



------------------------------------------------------------------------------------------------------------------
Section 1: Introduction
------------------------------------------------------------------------------------------------------------------

Checklist2 is a World of Warcraft addon written by Quezacolt designed to help you remember all the things that need to be done. These are things like:

* Dailies. With the daily quest limit raised to 25 by patch 2.4, it can be a problem for some remembering which dailies they have done and which are still unfinished.

* Levelling guides. Many users are using Checklist with a levelling guide - places to go, quests to pick up and complete, mobs to kill, etc.

* Alt character management. When you have multiple alts, it's pretty convenient to simply put all the items they need in a list then have your main buy them all from the AH in a single session. Less time is wasted logging into each and every alt... Trust me, I've been there :)

* Who needs what. Checklist can help you track what your party, guild or raid members need.

* Raid tactics. Broadcasting a note containing tactics for a particular boss to your raid or guild members who use Checklist2 can be very useful. Other uses could be minimum stat requirements for raiding, or important guild-wide notices. Yes, you could use the in-game mail, but Checklist Notes is often far more readable.


------------------------------------------------------------------------------------------------------------------
Section 2: Daily Use Guide - Notes
------------------------------------------------------------------------------------------------------------------

Simplicity in UI design was one of the "principles" driving the arrangement of every single element on the Checklist window. Something intuitive yet functional - easy to access, yet organized.

A simple tip to follow when using Checklist is that all red buttons (like the "Close" button) can only be left clicked. All "untextured" buttons (like the "Text Mode" button below) can be right-clicked to bring down a menu, or right-clicked for some other function.

The mode indicator in the Notes tab can be right-clicked to bring down mode select options, and left-clicked to toggle between the two modes.

The "Revert Edits" and "Save Note" buttons will automatically detect changes to the current note. If a change is detected, they will enable themselves, allowing you to revert back to the saved version, or save your changes.

Do take note that saving a list only stores the text in a location where they'll be saved by WoW when the UI engine is shut down, which happens at logouts/game exit and UI reloads. Improper shutdown of WoW like crashes or pressing ALT+F4 will result in changes during that session to not get written. This affects all addons and the entire UI, including most of the default UI's settings.

"Run Script" and "Import List" only work in Lua mode. Run Script takes the contents of the current note and runs them as a Lua script. More information about this can be found below. Import List takes the code in the note and attempts to turn it into a list. ONLY EXPORTED LIST CODE SHOULD BE IMPORTED INTO CHECKLIST. Invalid code will cause horrible bugs as Checklist will fail to find the data it expects to find inside a list.

In the Notes Menu you can select which note you would like to open. Right-clicking an existing note will open up options to delete, rename, send, or create a new note.

And that should be it for Checklist Notes. I hope you find this part of Checklist - and the entire addon, as a whole - to be very useful.

------------------------------------------------------------------------------------------------------------------
Section 3: Daily use guide - Checklist
------------------------------------------------------------------------------------------------------------------

Once again, the UI here should be quite intuitive and should not require much explanation.

"Uncheck All Tasks" and "Check All Tasks" do what they say - they check/uncheck everything in the current list.The tasks indicator can be right clicked to bring down task add/remove options, and left-clicked to force a full UI update. 

Right clicking a list in the List Menu will bring down options to rename, export, send, delete, or create a new list. 

Clicking the number beside a tasks's checkbox will open the setup menu. There you can edit the contents of a task.


------------------------------------------------------------------------------------------------------------------
Section 4: Contributors
------------------------------------------------------------------------------------------------------------------

The idea for this addon was originally suggested on the official UI & Macros Forum by Magictrix of the Hakkar US server. Other people who have given their suggestions include:

Abraxxis - Draenor
Heretical - Ysera
Akalabeth - Ner'zhul
Xaxziminraxb - Twisting Nether

Special thanks to Lunos on WoWInterface for translating this addon's texts into German, and Mandarion on Curse.com for giving so many brilliant suggestions in a single post that this one-man development team still hasn't finished them all...


------------------------------------------------------------------------------------------------------------------
Section 5: You can help, too!
------------------------------------------------------------------------------------------------------------------

Checklist is an addon for the community - it started as a simple suggestion, and I'd love to hear how users, well... USE this addon! Anything you suggest will help make this a better tool for everyone. 

No flaming, though. :)


------------------------------------------------------------------------------------------------------------------
Section 6: When Things Go Wrong - Reporting a Bug
------------------------------------------------------------------------------------------------------------------

As I am working solo on Checklist, it's difficult to test every single thing that users may do. Often, certain rarely done actions will result in an error. This can either be caused by the WoW API, Checklist's underlying libraries, or more commonly, Checklist's code.

When reporting an error, I need the following info:

 - Version (at the top of this manual)

 - Revision (again, at the top)

 - What were you doing before the bug occured?

 - What is the *exact* error message/messages, if any? If there are multiple errors, please include them all. I reccomend using an error handling addon to take the error, as they often give stack trace data - which makes tracking down the bug easier and faster.

 - Include steps on how to replicate the bug. This is very important - be as specific as you can.

Always update to the latest version and try replicating the error before reporting it. It may already be fixed.

------------------------------------------------------------------------------------------------------------------
Section 7: Distribution Sites
------------------------------------------------------------------------------------------------------------------

Checklist2 is only being released at Curse (http://wow.curse.com/) and WoWInterface (http://www.wowinterface.com/). The versions here are recommended for the average Joe and should be free from bugs.

Beta versions can be found in the Ace SVN (http://files.wowace.com/). For the more tech-savvy ones, if you have an SVN client (I recommend TortoiseSVN for this, google it!), you can checkout from:

http://svn.wowace.com/wowace/trunk/Checklist2/

I do not support updaters other than those provided by the above-mentioned websites. I reccomend using WoWAceUpdater, if you want an automated addon updater.

There are reports that Checklist2 fails to work when installed with the Curse Client. This issue is currently being addressed.

If you are experiencing problems with Checklist and downloaded it somewhere other than the sites mentioned, I will not be able to provide technical support.
]])

local helloWorld = [[local msg = "Hello, World!";
ChatFrame1:AddMessage(msg, 1, 1, 0);
UIErrorsFrame:AddMessage(msg, 1, 1, 0);
Checklist2:Message(msg);]]

function Checklist2:CreateHelpNote()
  self.db.profile.Notes["Hello, World!"] = {
    content = helloWorld,
    type = 2
  }
  self.db.profile.Notes["Checklist2 User's Manual"] = {
    content = userManual,
    type = 1
  }
  self:CollectNoteNames();
  self:NotesSelectScrollBarUpdate();
end

function Checklist2:CreateManual()
  self.db.profile.Notes["Checklist2 User's Manual"] = {
    content = userManual,
    type = 1
  }
  self:CollectNoteNames();
  self:NotesSelectScrollBarUpdate();
  
  if self:GetNoteInUse(true) == "Checklist2 User's Manual" then
    self.notesEditBox:SetText(userManual)
    self.forceNotesToTop = 0
  end
end
